#include <cstring>
#include <cstdio>
#include <cstdlib>
#include <cmath>

const int MAXN=200;
const int MAXM=10000;
const int MAXNUM = 1000000;

const int MAXS=250; // maximum possible number of divisors

int tab[MAXN][MAXM];
int total[MAXN][MAXS];
int divs[MAXS];
int next[MAXS][MAXS];

int divindex[MAXNUM+1];

int main()
{
	int a,b,c,d;
	int n,m;
	int k,L;
	int dn; //number of divisors of k


	freopen("dream.in","rt",stdin);
	scanf("%d%d",&n,&m);
	scanf("%d%d",&k,&L);
	for(a=0;a<n;a++)
		for(b=0;b<m;b++)
			scanf("%d",&tab[a][b]);
	fclose(stdin);


	// find all divisors of k
	dn=0;
	for(a=1;a<=k;a++)
		if(k%a==0) divs[dn++]=a;

	// productions of divisors
	for(a=0;a<dn;a++)
		for(b=a;b<dn;b++)
			for(c=dn-1;c>=0;c--)
				if(((long long)divs[a]*divs[b])%divs[c]==0)
				{
					next[a][b]=next[b][a]=c;
					break;
				}


	memset(divindex,0,sizeof(divindex));
	for(a=0;a<dn;a++)
	{
		c=divs[a];
		for(b=c;b<=MAXNUM;b+=c) divindex[b]=a;
	}


	int box;
	int cur_total1[MAXS], cur_total2[MAXS];

	memset(total,0,sizeof(total));

	for(a=0;a<m;a++)
	{
		c=divindex[tab[0][a]];
		total[0][c]=(total[0][c]+1)%L;
	}

	for(box=1;box<n;box++)
	{
		memset(cur_total1,0,sizeof(cur_total1));
		memset(cur_total2,0,sizeof(cur_total2));
		
		for(a=0;a<m;a++)
		{
			c=divindex[tab[box][a]];
			cur_total1[c]=(cur_total1[c]+1)%L;
		}

		for(a=0;a<dn;a++)
			cur_total2[a]=cur_total1[a];

		if(box<n-1)
		{
			// it's not the last box so we can take 2 numbers
			for(a=0;a<dn;a++)
				for(b=a;b<dn;b++)
					if(a!=b)
						cur_total2[next[a][b]]=(cur_total2[next[a][b]]+cur_total1[a]*cur_total1[b]*2)%L;
					else
						cur_total2[next[a][a]]=(cur_total2[next[a][a]]+cur_total1[a]*(cur_total1[a]-1))%L;
		}

		for(a=0;a<dn;a++)
			for(b=0;b<dn;b++)
				total[box][next[a][b]]=(total[box][next[a][b]]+total[box-1][a]*cur_total2[b])%L;
	}

	freopen("dream.out","wt",stdout);
	printf("%d\n",total[n-1][dn-1]%L);
	fclose(stdout);

	return 0;
}
